/*
 * $Id: DynamicContent.js,v 1.26 2005/04/29 09:59:29 subramani Exp $
 */
function addViewWithParamsToCA(viewToOpen,id,contentAreaName,requestParams,newViewId)
{
   updateViewInCA(viewToOpen,id,null,contentAreaName,null,true,newViewId,requestParams);
}

function addViewToCA(viewToOpen,id,tableAlias,contentAreaName,index,newViewId)
{
   updateViewInCA(viewToOpen,id,tableAlias,contentAreaName,index,true,newViewId);
}
	
function updateViewInCA(viewToOpen,id,tableAlias,contentAreaName,index,addToList,newViewId,requestParams)
{
  var uniqueId = getUniqueId(id);
  var actUrl = "ShowViewInContentAreaAction.do?VIEW_TO_OPEN=" + viewToOpen;
  if(contentAreaName != null){
       actUrl = actUrl + "&CONTENTAREANAME=" + contentAreaName;
  }
  if(newViewId != null)
  {
     actUrl = actUrl + "&VIEW_UNIQUEID=" + newViewId;
  }
  if(addToList)
  {
     actUrl = actUrl + "&ADDTOLIST=true";
  }
  if(tableAlias != null)
  {
     actUrl  = getInvokeActionFromView(actUrl,id,tableAlias,index);
  }
  if(requestParams != null){
	  actUrl = actUrl + "&" + requestParams;
  }
  handleSubRequest(actUrl);
  //openURL(actUrl);
}


function getDacArray(contentAreaName)
{
    contentAreaName = getContentAreaName(contentAreaName);
    var dac = stateData[ROOT_VIEW_ID][contentAreaName+"_LIST"];
    if(!dac){  return null; }
    return dac.split("-");
}

function updateDac(dacString,contentAreaName)
{
   stateData[ROOT_VIEW_ID][getContentAreaName(contentAreaName)+"_LIST"] = dacString;
}

function popContentArea(index,contentAreaName,dontRefresh)
{
    var dacArr = getDacArray(contentAreaName);
    contentAreaName = getContentAreaName(contentAreaName);
    if(index == -1)
    {
       index = dacArr.length -1;
    }
    while( (dacArr.length-1) > index)
    {
	dacArr.pop();
    }
    var dacList = dacArr[0];
    for(var i=1; i<dacArr.length; i++)
    {
    	dacList = dacList + "-" + dacArr[i];
    }
    updateDac(dacList,contentAreaName);
    if(!dontRefresh)
    {
        if(useSubRequest)
        {  
          refreshSubView(ROOT_VIEW_ID);    
        }
	else
        {
           refreshCurrentView();
        }
    }
}

function replaceContentArea(replacingView,contentAreaName,removeState)
{
   var dacArr = getDacArray(contentAreaName);
   if(!dacArr){return;}
   var viewToReplace = getUniqueId(dacArr.pop());
   if(viewToReplace == replacingView)
   {
     return;
   }
   replaceView(viewToReplace,replacingView);
   if(removeState)
   {     
     for(var i = 0; i < dacArr.length; i++)
     {
       var curId = dacArr[i];
       if(replacingView != getUniqueId(curId))
       { 	
          removeStateForView(getUniqueId(curId));
       }
     }
   }
   var breadCrumbDiv = document.getElementById("BreadCrumbs");
   if(breadCrumbDiv)
   {
     breadCrumbDiv.innerHTML = "";
   }
   updateDac(getReferenceId(replacingView),contentAreaName);
}

function closeView(uniqueId)
{
  if(uniqueId == ROOT_VIEW_ID)
  {
     window.close();
     return;
  }
  var pos = getDCAPosition(uniqueId);
  if(pos == -1)
  {//May be log
    return;
  }

  var dca = getContentAreaFromState(uniqueId);
  popContentArea(pos -1,dca);
}

function getDCAPosition(uniqueId)
{
   var dca = getContentAreaFromState(uniqueId);
   var arr = getDacArray(dca);
   var refId = getReferenceId(uniqueId);
   for(var i = 0; i < arr.length; i++)
   {
      if(arr[i] == refId)
      {
         return i;
      } 
   } 
   return -1;
}

function getContentAreaName(contentAreaName)
{
   if(contentAreaName == null)
   {
     return ROOT_VIEW_ID + "_CONTENTAREA";
   }
   return contentAreaName;
} 

function getContentAreaFromState(uniqueId)
{
  var dca =  stateData[uniqueId]["PDCA"];
  var curView= uniqueId;
  var viewId = getReferenceId(uniqueId);
  while(dca == null)
  {
    var parentViewId = stateData[curView]["_PV"];
    if(parentViewId == null)
    {
      return null;
    }
    curView = getUniqueId(parentViewId);
    var parentState = stateData[curView];
    if(parentState == null)
    {
      return null;
    }
    dca = parentState["PDCA"];
    viewId = parentViewId;
    //Checking for cacheing!!    
  }
  if(dca != null)
  {
    var dcArr = getDacArray(dca);
    if(dcArr == null)
    {
      return null;
    }
    for(var i = 0; i < dcArr.length;i++)
    {
      if(dcArr[i] == viewId)
      {
        return dca;
      }
    }
  }
  return null;
}

function createBreadCrumbs(contentAreaName,win)
{
  var contentAreaName = getContentAreaName(contentAreaName);
  var breadCrumbDiv = win.document.getElementById("BreadCrumbs");
  var hiddenDiv = win.document.getElementById(contentAreaName + "_BC");
  breadCrumbDiv.innerHTML = hiddenDiv.innerHTML;   
}


function moveBreadCrumb(direction)
{
   var incr = -1;
   if(direction == 1)
   {//right
     incr = 1;
   }
   startBCIndex += incr;
   endBCIndex += incr;
   createBreadCrumbs(null);
}
